//
//  Model.swift
//  Notities
//
//  Created by Developer on 31-03-17.
//  Copyright © 2017 iOS Academie. All rights reserved.
//

import Foundation
import CoreData

class Model {
  static let shared = Model()

  var count: Int {
    let fetchRequest = NSFetchRequest<Notitie>(entityName: "Notitie")
    return try! persistentContainer.viewContext.count(for: fetchRequest)
  }
  
  func notitie(op index: Int) -> Notitie {
    let fetchRequest = NSFetchRequest<Notitie>(entityName: "Notitie")
    fetchRequest.fetchOffset = index
    fetchRequest.fetchLimit = 1
    let sortDescriptor = NSSortDescriptor(key: "datum", ascending: false)
    fetchRequest.sortDescriptors = [sortDescriptor]
    return try! persistentContainer.viewContext.fetch(fetchRequest).first!
  }
  
  func maakNotitie(titel: String) {
    let notitie = NSEntityDescription.insertNewObject(forEntityName: "Notitie", into: persistentContainer.viewContext) as! Notitie
    notitie.datum = Date() as NSDate!
    notitie.titel = titel
    
    saveContext()
  }
  
  func wijzig(titel: String, voor notitie: Notitie) {
    notitie.titel = titel
    saveContext()
  }
  
  func verwijder(notitie: Notitie) {
    persistentContainer.viewContext.delete(notitie)
    saveContext()
  }
  
  
  // MARK: - Core Data stack
  
  lazy var persistentContainer: NSPersistentContainer = {
    let container = NSPersistentContainer(name: "Notities")
    container.loadPersistentStores(completionHandler: { (storeDescription, error) in
      if let error = error as NSError? {
        fatalError("Unresolved error \(error), \(error.userInfo)")
      }
    })
    return container
  }()
  
  // MARK: - Core Data Saving support
  
  func saveContext () {
    let context = persistentContainer.viewContext
    if context.hasChanges {
      do {
        try context.save()
      } catch {
        let nserror = error as NSError
        fatalError("Unresolved error \(nserror), \(nserror.userInfo)")
      }
    }
  }
  
}
